window.Gleam.initSearch([{"doc":"gleamy_structures","title":"gleamy_structures","content":"# gleamy_structures\n\n[![Package Version](https://img.shields.io/hexpm/v/gleamy_structures)](https://hex.pm/packages/gleamy_structures)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gleamy_structures/)\n\nData structures in pure Gleam.\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add gleamy_structures\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/gleamy_structures&gt;.\n\n## Contributions Welcome\nFeel free to make PRs, issues, or requests for new data structures and functions :) Especially welcome would be more rigorous tests and reviews of the implementation compared to source materials.\n","url":"index.html"},{"doc":"gleamy_structures/heap/leftist_heap","title":"Heap","content":"pub opaque type Heap(a)\n\n\nSynonyms:\ngleamy_structures/heap/leftist_heap.Heap\ngleamy_structures/heap/leftist_heap Heap","url":"gleamy_structures/heap/leftist_heap.html#Heap"},{"doc":"gleamy_structures/heap/leftist_heap","title":"delete_min","content":"pub fn delete_min(heap: Heap(a)) -&gt; Result(#(a, Heap(a)), Nil)\n\nSynonyms:\ngleamy_structures/heap/leftist_heap.delete_min\ngleamy_structures/heap/leftist_heap delete_min","url":"gleamy_structures/heap/leftist_heap.html#delete_min"},{"doc":"gleamy_structures/heap/leftist_heap","title":"find_min","content":"pub fn find_min(heap: Heap(a)) -&gt; Result(a, Nil)\n\nSynonyms:\ngleamy_structures/heap/leftist_heap.find_min\ngleamy_structures/heap/leftist_heap find_min","url":"gleamy_structures/heap/leftist_heap.html#find_min"},{"doc":"gleamy_structures/heap/leftist_heap","title":"insert","content":"pub fn insert(heap: Heap(a), item: a) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/heap/leftist_heap.insert\ngleamy_structures/heap/leftist_heap insert","url":"gleamy_structures/heap/leftist_heap.html#insert"},{"doc":"gleamy_structures/heap/leftist_heap","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/heap/leftist_heap.new\ngleamy_structures/heap/leftist_heap new","url":"gleamy_structures/heap/leftist_heap.html#new"},{"doc":"gleamy_structures/heap/leftist_heap","title":"gleamy_structures/heap/leftist_heap","content":"","url":"gleamy_structures/heap/leftist_heap.html"},{"doc":"gleamy_structures/heap/pairing_heap","title":"Heap","content":"pub opaque type Heap(a)\n\n\nSynonyms:\ngleamy_structures/heap/pairing_heap.Heap\ngleamy_structures/heap/pairing_heap Heap","url":"gleamy_structures/heap/pairing_heap.html#Heap"},{"doc":"gleamy_structures/heap/pairing_heap","title":"delete_min","content":"pub fn delete_min(heap: Heap(a)) -&gt; Result(#(a, Heap(a)), Nil)\n\nSynonyms:\ngleamy_structures/heap/pairing_heap.delete_min\ngleamy_structures/heap/pairing_heap delete_min","url":"gleamy_structures/heap/pairing_heap.html#delete_min"},{"doc":"gleamy_structures/heap/pairing_heap","title":"find_min","content":"pub fn find_min(heap: Heap(a)) -&gt; Result(a, Nil)\n\nSynonyms:\ngleamy_structures/heap/pairing_heap.find_min\ngleamy_structures/heap/pairing_heap find_min","url":"gleamy_structures/heap/pairing_heap.html#find_min"},{"doc":"gleamy_structures/heap/pairing_heap","title":"insert","content":"pub fn insert(heap: Heap(a), key: a) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/heap/pairing_heap.insert\ngleamy_structures/heap/pairing_heap insert","url":"gleamy_structures/heap/pairing_heap.html#insert"},{"doc":"gleamy_structures/heap/pairing_heap","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/heap/pairing_heap.new\ngleamy_structures/heap/pairing_heap new","url":"gleamy_structures/heap/pairing_heap.html#new"},{"doc":"gleamy_structures/heap/pairing_heap","title":"gleamy_structures/heap/pairing_heap","content":"","url":"gleamy_structures/heap/pairing_heap.html"},{"doc":"gleamy_structures/priority_queue","title":"Queue","content":"pub type Queue(a) =\n  heap.Heap(a)\n\n\nSynonyms:\ngleamy_structures/priority_queue.Queue\ngleamy_structures/priority_queue Queue","url":"gleamy_structures/priority_queue.html#Queue"},{"doc":"gleamy_structures/priority_queue","title":"count","content":"pub fn count(queue: Heap(a)) -&gt; Int\n\nSynonyms:\ngleamy_structures/priority_queue.count\ngleamy_structures/priority_queue count","url":"gleamy_structures/priority_queue.html#count"},{"doc":"gleamy_structures/priority_queue","title":"from_list","content":"pub fn from_list(\n  list: List(a),\n  compare: fn(a, a) -&gt; Order,\n) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/priority_queue.from_list\ngleamy_structures/priority_queue from_list","url":"gleamy_structures/priority_queue.html#from_list"},{"doc":"gleamy_structures/priority_queue","title":"is_empty","content":"pub fn is_empty(queue: Heap(a)) -&gt; Bool\n\nSynonyms:\ngleamy_structures/priority_queue.is_empty\ngleamy_structures/priority_queue is_empty","url":"gleamy_structures/priority_queue.html#is_empty"},{"doc":"gleamy_structures/priority_queue","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/priority_queue.new\ngleamy_structures/priority_queue new","url":"gleamy_structures/priority_queue.html#new"},{"doc":"gleamy_structures/priority_queue","title":"peek","content":"pub fn peek(from queue: Heap(a)) -&gt; Result(a, Nil)\n\nSynonyms:\ngleamy_structures/priority_queue.peek\ngleamy_structures/priority_queue peek","url":"gleamy_structures/priority_queue.html#peek"},{"doc":"gleamy_structures/priority_queue","title":"pop","content":"pub fn pop(from queue: Heap(a)) -&gt; Result(#(a, Heap(a)), Nil)\n\nSynonyms:\ngleamy_structures/priority_queue.pop\ngleamy_structures/priority_queue pop","url":"gleamy_structures/priority_queue.html#pop"},{"doc":"gleamy_structures/priority_queue","title":"push","content":"pub fn push(onto queue: Heap(a), this item: a) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/priority_queue.push\ngleamy_structures/priority_queue push","url":"gleamy_structures/priority_queue.html#push"},{"doc":"gleamy_structures/priority_queue","title":"reorder","content":"pub fn reorder(\n  queue: Heap(a),\n  compare: fn(a, a) -&gt; Order,\n) -&gt; Heap(a)\n\nSynonyms:\ngleamy_structures/priority_queue.reorder\ngleamy_structures/priority_queue reorder","url":"gleamy_structures/priority_queue.html#reorder"},{"doc":"gleamy_structures/priority_queue","title":"to_list","content":"pub fn to_list(queue: Heap(a)) -&gt; List(a)\n\nSynonyms:\ngleamy_structures/priority_queue.to_list\ngleamy_structures/priority_queue to_list","url":"gleamy_structures/priority_queue.html#to_list"},{"doc":"gleamy_structures/priority_queue","title":"gleamy_structures/priority_queue","content":"","url":"gleamy_structures/priority_queue.html"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"Tree","content":"pub opaque type Tree(k, v)\n\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.Tree\ngleamy_structures/tree/red_black_tree_kv Tree","url":"gleamy_structures/tree/red_black_tree_kv.html#Tree"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"clear","content":"pub fn clear(tree: Tree(a, b)) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.clear\ngleamy_structures/tree/red_black_tree_kv clear","url":"gleamy_structures/tree/red_black_tree_kv.html#clear"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"delete","content":"pub fn delete(tree: Tree(a, b), key: a) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.delete\ngleamy_structures/tree/red_black_tree_kv delete","url":"gleamy_structures/tree/red_black_tree_kv.html#delete"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"draw","content":"pub fn draw(\n  tree: Tree(a, b),\n  to_string: fn(a, b) -&gt; String,\n) -&gt; String\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.draw\ngleamy_structures/tree/red_black_tree_kv draw","url":"gleamy_structures/tree/red_black_tree_kv.html#draw"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"find","content":"pub fn find(tree: Tree(a, b), key: a) -&gt; Result(#(a, b), Nil)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.find\ngleamy_structures/tree/red_black_tree_kv find","url":"gleamy_structures/tree/red_black_tree_kv.html#find"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"fold","content":"pub fn fold(tree: Tree(a, b), acc: c, fun: fn(c, a, b) -&gt; c) -&gt; c\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.fold\ngleamy_structures/tree/red_black_tree_kv fold","url":"gleamy_structures/tree/red_black_tree_kv.html#fold"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"foldr","content":"pub fn foldr(\n  tree: Tree(a, b),\n  acc: c,\n  fun: fn(c, a, b) -&gt; c,\n) -&gt; c\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.foldr\ngleamy_structures/tree/red_black_tree_kv foldr","url":"gleamy_structures/tree/red_black_tree_kv.html#foldr"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"insert","content":"pub fn insert(tree: Tree(a, b), key: a, value: b) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.insert\ngleamy_structures/tree/red_black_tree_kv insert","url":"gleamy_structures/tree/red_black_tree_kv.html#insert"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree_kv.new\ngleamy_structures/tree/red_black_tree_kv new","url":"gleamy_structures/tree/red_black_tree_kv.html#new"},{"doc":"gleamy_structures/tree/red_black_tree_kv","title":"gleamy_structures/tree/red_black_tree_kv","content":"","url":"gleamy_structures/tree/red_black_tree_kv.html"},{"doc":"gleamy_structures/map","title":"Map","content":"pub type Map(k, v) =\n  tree.Tree(k, v)\n\n\nSynonyms:\ngleamy_structures/map.Map\ngleamy_structures/map Map","url":"gleamy_structures/map.html#Map"},{"doc":"gleamy_structures/map","title":"count","content":"pub fn count(map: Tree(a, b)) -&gt; Int\n\nSynonyms:\ngleamy_structures/map.count\ngleamy_structures/map count","url":"gleamy_structures/map.html#count"},{"doc":"gleamy_structures/map","title":"delete","content":"pub fn delete(from map: Tree(a, b), this key: a) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.delete\ngleamy_structures/map delete","url":"gleamy_structures/map.html#delete"},{"doc":"gleamy_structures/map","title":"filter","content":"pub fn filter(\n  in map: Tree(a, b),\n  for property: fn(a, b) -&gt; Bool,\n) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.filter\ngleamy_structures/map filter","url":"gleamy_structures/map.html#filter"},{"doc":"gleamy_structures/map","title":"find","content":"pub fn find(\n  in map: Tree(a, b),\n  key key: a,\n) -&gt; Result(#(a, b), Nil)\n\nSynonyms:\ngleamy_structures/map.find\ngleamy_structures/map find","url":"gleamy_structures/map.html#find"},{"doc":"gleamy_structures/map","title":"fold","content":"pub fn fold(\n  over map: Tree(a, b),\n  from initial: c,\n  with reducer: fn(c, a, b) -&gt; c,\n) -&gt; c\n\nSynonyms:\ngleamy_structures/map.fold\ngleamy_structures/map fold","url":"gleamy_structures/map.html#fold"},{"doc":"gleamy_structures/map","title":"from_list","content":"pub fn from_list(\n  members: List(#(a, b)),\n  compare: fn(a, a) -&gt; Order,\n) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.from_list\ngleamy_structures/map from_list","url":"gleamy_structures/map.html#from_list"},{"doc":"gleamy_structures/map","title":"has_key","content":"pub fn has_key(in map: Tree(a, b), key key: a) -&gt; Bool\n\nSynonyms:\ngleamy_structures/map.has_key\ngleamy_structures/map has_key","url":"gleamy_structures/map.html#has_key"},{"doc":"gleamy_structures/map","title":"insert","content":"pub fn insert(\n  into map: Tree(a, b),\n  key key: a,\n  value value: b,\n) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.insert\ngleamy_structures/map insert","url":"gleamy_structures/map.html#insert"},{"doc":"gleamy_structures/map","title":"merge","content":"pub fn merge(\n  this first: Tree(a, b),\n  and second: Tree(a, b),\n) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.merge\ngleamy_structures/map merge","url":"gleamy_structures/map.html#merge"},{"doc":"gleamy_structures/map","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.new\ngleamy_structures/map new","url":"gleamy_structures/map.html#new"},{"doc":"gleamy_structures/map","title":"take","content":"pub fn take(\n  from map: Tree(a, b),\n  keeping desired: List(a),\n) -&gt; Tree(a, b)\n\nSynonyms:\ngleamy_structures/map.take\ngleamy_structures/map take","url":"gleamy_structures/map.html#take"},{"doc":"gleamy_structures/map","title":"to_list","content":"pub fn to_list(map: Tree(a, b)) -&gt; List(#(a, b))\n\nSynonyms:\ngleamy_structures/map.to_list\ngleamy_structures/map to_list","url":"gleamy_structures/map.html#to_list"},{"doc":"gleamy_structures/map","title":"gleamy_structures/map","content":"","url":"gleamy_structures/map.html"},{"doc":"gleamy_structures/tree/red_black_tree","title":"Tree","content":"pub opaque type Tree(a)\n\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.Tree\ngleamy_structures/tree/red_black_tree Tree","url":"gleamy_structures/tree/red_black_tree.html#Tree"},{"doc":"gleamy_structures/tree/red_black_tree","title":"clear","content":"pub fn clear(tree: Tree(a)) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.clear\ngleamy_structures/tree/red_black_tree clear","url":"gleamy_structures/tree/red_black_tree.html#clear"},{"doc":"gleamy_structures/tree/red_black_tree","title":"delete","content":"pub fn delete(tree: Tree(a), key: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.delete\ngleamy_structures/tree/red_black_tree delete","url":"gleamy_structures/tree/red_black_tree.html#delete"},{"doc":"gleamy_structures/tree/red_black_tree","title":"draw","content":"pub fn draw(tree: Tree(a), to_string: fn(a) -&gt; String) -&gt; String\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.draw\ngleamy_structures/tree/red_black_tree draw","url":"gleamy_structures/tree/red_black_tree.html#draw"},{"doc":"gleamy_structures/tree/red_black_tree","title":"find","content":"pub fn find(tree: Tree(a), key: a) -&gt; Result(a, Nil)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.find\ngleamy_structures/tree/red_black_tree find","url":"gleamy_structures/tree/red_black_tree.html#find"},{"doc":"gleamy_structures/tree/red_black_tree","title":"fold","content":"pub fn fold(tree: Tree(a), acc: b, fun: fn(b, a) -&gt; b) -&gt; b\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.fold\ngleamy_structures/tree/red_black_tree fold","url":"gleamy_structures/tree/red_black_tree.html#fold"},{"doc":"gleamy_structures/tree/red_black_tree","title":"foldr","content":"pub fn foldr(tree: Tree(a), acc: b, fun: fn(b, a) -&gt; b) -&gt; b\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.foldr\ngleamy_structures/tree/red_black_tree foldr","url":"gleamy_structures/tree/red_black_tree.html#foldr"},{"doc":"gleamy_structures/tree/red_black_tree","title":"insert","content":"pub fn insert(tree: Tree(a), key: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.insert\ngleamy_structures/tree/red_black_tree insert","url":"gleamy_structures/tree/red_black_tree.html#insert"},{"doc":"gleamy_structures/tree/red_black_tree","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/red_black_tree.new\ngleamy_structures/tree/red_black_tree new","url":"gleamy_structures/tree/red_black_tree.html#new"},{"doc":"gleamy_structures/tree/red_black_tree","title":"gleamy_structures/tree/red_black_tree","content":"","url":"gleamy_structures/tree/red_black_tree.html"},{"doc":"gleamy_structures/set","title":"Set","content":"pub type Set(a) =\n  tree.Tree(a)\n\n\nSynonyms:\ngleamy_structures/set.Set\ngleamy_structures/set Set","url":"gleamy_structures/set.html#Set"},{"doc":"gleamy_structures/set","title":"contains","content":"pub fn contains(in set: Tree(a), this member: a) -&gt; Bool\n\nSynonyms:\ngleamy_structures/set.contains\ngleamy_structures/set contains","url":"gleamy_structures/set.html#contains"},{"doc":"gleamy_structures/set","title":"count","content":"pub fn count(set: Tree(a)) -&gt; Int\n\nSynonyms:\ngleamy_structures/set.count\ngleamy_structures/set count","url":"gleamy_structures/set.html#count"},{"doc":"gleamy_structures/set","title":"delete","content":"pub fn delete(from set: Tree(a), this member: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.delete\ngleamy_structures/set delete","url":"gleamy_structures/set.html#delete"},{"doc":"gleamy_structures/set","title":"filter","content":"pub fn filter(\n  in set: Tree(a),\n  for property: fn(a) -&gt; Bool,\n) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.filter\ngleamy_structures/set filter","url":"gleamy_structures/set.html#filter"},{"doc":"gleamy_structures/set","title":"fold","content":"pub fn fold(\n  over set: Tree(a),\n  from initial: b,\n  with reducer: fn(b, a) -&gt; b,\n) -&gt; b\n\nSynonyms:\ngleamy_structures/set.fold\ngleamy_structures/set fold","url":"gleamy_structures/set.html#fold"},{"doc":"gleamy_structures/set","title":"from_list","content":"pub fn from_list(\n  members: List(a),\n  compare: fn(a, a) -&gt; Order,\n) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.from_list\ngleamy_structures/set from_list","url":"gleamy_structures/set.html#from_list"},{"doc":"gleamy_structures/set","title":"insert","content":"pub fn insert(into set: Tree(a), this member: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.insert\ngleamy_structures/set insert","url":"gleamy_structures/set.html#insert"},{"doc":"gleamy_structures/set","title":"intersection","content":"pub fn intersection(\n  of first: Tree(a),\n  and second: Tree(a),\n) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.intersection\ngleamy_structures/set intersection","url":"gleamy_structures/set.html#intersection"},{"doc":"gleamy_structures/set","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.new\ngleamy_structures/set new","url":"gleamy_structures/set.html#new"},{"doc":"gleamy_structures/set","title":"take","content":"pub fn take(\n  from set: Tree(a),\n  keeping desired: List(a),\n) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.take\ngleamy_structures/set take","url":"gleamy_structures/set.html#take"},{"doc":"gleamy_structures/set","title":"to_list","content":"pub fn to_list(set: Tree(a)) -&gt; List(a)\n\nSynonyms:\ngleamy_structures/set.to_list\ngleamy_structures/set to_list","url":"gleamy_structures/set.html#to_list"},{"doc":"gleamy_structures/set","title":"union","content":"pub fn union(of first: Tree(a), and second: Tree(a)) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/set.union\ngleamy_structures/set union","url":"gleamy_structures/set.html#union"},{"doc":"gleamy_structures/set","title":"gleamy_structures/set","content":"","url":"gleamy_structures/set.html"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"Tree","content":"pub opaque type Tree(a)\n\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.Tree\ngleamy_structures/tree/binary_search_tree Tree","url":"gleamy_structures/tree/binary_search_tree.html#Tree"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"clear","content":"pub fn clear(tree: Tree(a)) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.clear\ngleamy_structures/tree/binary_search_tree clear","url":"gleamy_structures/tree/binary_search_tree.html#clear"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"delete","content":"pub fn delete(tree: Tree(a), key: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.delete\ngleamy_structures/tree/binary_search_tree delete","url":"gleamy_structures/tree/binary_search_tree.html#delete"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"draw","content":"pub fn draw(tree: Tree(a), to_string: fn(a) -&gt; String) -&gt; String\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.draw\ngleamy_structures/tree/binary_search_tree draw","url":"gleamy_structures/tree/binary_search_tree.html#draw"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"find","content":"pub fn find(tree: Tree(a), key: a) -&gt; Result(a, Nil)\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.find\ngleamy_structures/tree/binary_search_tree find","url":"gleamy_structures/tree/binary_search_tree.html#find"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"fold","content":"pub fn fold(tree: Tree(a), acc: b, fun: fn(b, a) -&gt; b) -&gt; b\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.fold\ngleamy_structures/tree/binary_search_tree fold","url":"gleamy_structures/tree/binary_search_tree.html#fold"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"insert","content":"pub fn insert(tree: Tree(a), key: a) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.insert\ngleamy_structures/tree/binary_search_tree insert","url":"gleamy_structures/tree/binary_search_tree.html#insert"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"new","content":"pub fn new(compare: fn(a, a) -&gt; Order) -&gt; Tree(a)\n\nSynonyms:\ngleamy_structures/tree/binary_search_tree.new\ngleamy_structures/tree/binary_search_tree new","url":"gleamy_structures/tree/binary_search_tree.html#new"},{"doc":"gleamy_structures/tree/binary_search_tree","title":"gleamy_structures/tree/binary_search_tree","content":"","url":"gleamy_structures/tree/binary_search_tree.html"},{"doc":"gleamy_structures/non_empty_list","title":"NonEmptyList","content":"pub type NonEmptyList(a) {\n  End(first: a)\n  Next(first: a, rest: NonEmptyList(a))\n}\n\nEnd(first: a)\n\n\nNext(first: a, rest: NonEmptyList(a))\n\n\nSynonyms:\ngleamy_structures/non_empty_list.NonEmptyList\ngleamy_structures/non_empty_list NonEmptyList","url":"gleamy_structures/non_empty_list.html#NonEmptyList"},{"doc":"gleamy_structures/non_empty_list","title":"count","content":"pub fn count(list: NonEmptyList(a)) -&gt; Int\n\nSynonyms:\ngleamy_structures/non_empty_list.count\ngleamy_structures/non_empty_list count","url":"gleamy_structures/non_empty_list.html#count"},{"doc":"gleamy_structures/non_empty_list","title":"filter","content":"pub fn filter(\n  list: NonEmptyList(a),\n  predicate: fn(a) -&gt; Bool,\n) -&gt; List(a)\n\nSynonyms:\ngleamy_structures/non_empty_list.filter\ngleamy_structures/non_empty_list filter","url":"gleamy_structures/non_empty_list.html#filter"},{"doc":"gleamy_structures/non_empty_list","title":"fold","content":"pub fn fold(\n  over list: NonEmptyList(a),\n  from initial: b,\n  with fun: fn(b, a) -&gt; b,\n) -&gt; b\n\nSynonyms:\ngleamy_structures/non_empty_list.fold\ngleamy_structures/non_empty_list fold","url":"gleamy_structures/non_empty_list.html#fold"},{"doc":"gleamy_structures/non_empty_list","title":"from_list","content":"pub fn from_list(list: List(a)) -&gt; Result(NonEmptyList(a), Nil)\n\nSynonyms:\ngleamy_structures/non_empty_list.from_list\ngleamy_structures/non_empty_list from_list","url":"gleamy_structures/non_empty_list.html#from_list"},{"doc":"gleamy_structures/non_empty_list","title":"map","content":"pub fn map(\n  list: NonEmptyList(a),\n  transform: fn(a) -&gt; b,\n) -&gt; NonEmptyList(b)\n\nSynonyms:\ngleamy_structures/non_empty_list.map\ngleamy_structures/non_empty_list map","url":"gleamy_structures/non_empty_list.html#map"},{"doc":"gleamy_structures/non_empty_list","title":"reverse","content":"pub fn reverse(list: NonEmptyList(a)) -&gt; NonEmptyList(a)\n\nSynonyms:\ngleamy_structures/non_empty_list.reverse\ngleamy_structures/non_empty_list reverse","url":"gleamy_structures/non_empty_list.html#reverse"},{"doc":"gleamy_structures/non_empty_list","title":"to_list","content":"pub fn to_list(list: NonEmptyList(a)) -&gt; List(a)\n\nSynonyms:\ngleamy_structures/non_empty_list.to_list\ngleamy_structures/non_empty_list to_list","url":"gleamy_structures/non_empty_list.html#to_list"},{"doc":"gleamy_structures/non_empty_list","title":"gleamy_structures/non_empty_list","content":"","url":"gleamy_structures/non_empty_list.html"}]);